function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

carrier = {
	blue = { "bShip","bShip"},
	red = {}
}

navalzone = {
	blue = { "bShip","bShip"},
	red = {"rShip","rShip","rShip"}
}

airfield = {
	blue = { "bInfantry", "bArmor", "bSam", "bSam2", "bSam3"},
	red = {"rInfantry", "rArmor", "rSam", "rSam2", "rSam3" }
}

farp = {
	blue = {"bInfantry", "bArmor", "bSam"},
	red = {"rInfantry", "rArmor", "rSam" }
}

regularzone = {
	blue = {"bInfantry", "bArmor", "bSamIR"},
	red = {"rInfantry", "rArmor", "rSamIR" }
}

specialSAM = {
	blue = {"bInfantry", "bSamIR","bInfantry", "bInfantry", "bSamBig" },
	red = {"rInfantry", "rSamIR", "rInfantry", "rInfantry", "rSamBig" }
}

specialKrasnodar = {
	blue = {"bInfantry", "bSamIR","bSam2", "bSam3", "bSamBig", "bSamFinal" },
	red = {"rInfantry", "rSamIR", "rSam2", "rSam3", "rSamBig", "rSamFinal" }
}

convoy = {
	blue = {"bInfantry"},
	red = {"rInfantry", "rInfantry", "rArmor"}
}

cargoSpawns = {
	["Anapa"] = {"c1","c2","c3"},
	["Bravo"] = {"c6","c7"},
	["Krymsk"] = {"c8","c9","c10"},
	["Factory"] = {"c4","c5","c11"},
	["Echo"] = {"c12","c13"}
}

farpSupply = {
	["Bravo"] = {"bravoFuelAndAmmo"},
	["Echo"] = {"echoFuelAndAmmo"}
}

cargoAccepts = {
	anapa = allExcept(cargoSpawns, 'Anapa'),
	bravo =  allExcept(cargoSpawns, 'Bravo'),
	krymsk =  allExcept(cargoSpawns, 'Krymsk'),
	factory =  allExcept(cargoSpawns, 'Factory'),
	echo =  allExcept(cargoSpawns, 'Echo'),
	general = allExcept(cargoSpawns)
}

flavor = {
	anapa = 'WPT 1\nHome base',
	carrier = 'Carrier group',
	alpha='WPT 2\nDefensive position next to the town of Natuhaevskaya',
	bravo='WPT 3\nFARP next to the town of Damanka.\nWill let us launch helicopter attacks from a bit closer to the action.',
	charlie='WPT 4\nDefensive position next to an old TV tower.\nWill provide allied air patrol to help capture Bravo',
	convoy='WPT 5\nSupply convoy detained north of Bravo.\nKeep damage to the trucks to a minimum while liberating this area.\nWe could really use the supplies.',
	krymsk='WPT 7\nAirbase next to the city of Krymsk.\nCapturing it will provide us with valuable aircraft to use for our cause.',
	radio='WPT 8\nRadio atenna on the outskirts of Krymsk.\nIf we capture it, we can launch AWACS from the nearby airport\nto get some much needed intel on the enemy.',
	oilfields='WPT 6\nOil extraction and Refinery north of Krymsk.\nCapture it to get a steady stream of income, or just destroy it to put a hole in the enemy wallet.',
	delta='WPT 10\nDefensive position out in the middle of nowhere',
	factory='WPT 9\nWeapon factory next to the town of Homskiy.\nWe can use it to resupply nearby bases.\nIt will also provide a steady stream of income.',
	samsite='WPT 11\nHome to an old SA-2 site.\nIf we capture it, we might be able to get some use out of it.',
	foxtrot='WPT 13\nDefensive position with a nice view of a lake',
	echo='WPT 12\nFARP next to the city of Krasnodar.\nCapturing it will let us operate our helicopters in the area.',
	krasnodar='WPT 14\nAirbase next to the city of Krasnodar.\nThe home base of our enemy. Capture it to deprive them of their most valuable asset.',
	novorossiysk='WPT 15\nAirbase next to the town of Novorossiysk',
	gelendzhik='WPT 16\nAirbase position next to the town of Gelendzhik',
	labinsk='WPT 17\nDefensive position next to the town of Labinsk',
	goryachiy='WPT 18\nDefensive position next to the town of Goryachiy',
	shaumyan='WPT 19\nDefensive position next to the town of Shaumyan',
	maykop='WPT 17\nAirbase position next to the town of Maykop',
	volkonka='WPT 17\nDefensive position next to the town of Volkonka',
	psebay='WPT 17\nDefensive position next to the town of Psebay',
	sochi='WPT 17\nAirbase position next to the town of Sochi',
	gudauta='WPT 17\nAirbase position next to the town of Gudauta',
	sukhumi='WPT 17\nAirbase position next to the town of Sukhumi',
	cherkessk='WPT 17\nDefensive position next to the town of Cherkessk',
	mineralnye='WPT 17\nAirbase position next to the town of Mineralnye',
	teberda='WPT 17\nDefensive position next to the town of Teberda',
	tyrnyuaz='WPT 17\nDefensive position next to the town of Tyrnyuaz',
	nalchik='WPT 17\nDefensive position next to the town of Nalchik',
	mozdok='WPT 17\nDefensive position next to the town of Mozdok',
	beslan='WPT 17\nDefensive position next to the town of Beslan',
	kazbegi='WPT 17\nDefensive position next to the town of Kazbegi',
	chiha='WPT 17\nDefensive position next to the town of Chiha',
	senaki='WPT 17\nAirbase position next to the town of Senaki',
	kutaisi='WPT 17\nAirbase position next to the town of Kutaisi',
	kobuleti='WPT 17\nAirbase position next to the town of Kobuleti',
	batumi='WPT 17\nAirbase position next to the town of Batumi',
	mountainpass='WPT 17\nDefensive position next to the town of Mountain Pass',
	khashuri='WPT 17\nDefensive position next to the town of Khashuri',
	trainingcamp='WPT 17\nDefensive position next to the town of Training Camp',
	kaspi='WPT 17\nDefensive position next to the town of Kaspi',
	twinlakes='WPT 17\nDefensive position next to the town of Twin Lakes',
	tblisi='WPT 17\nDefensive position next to the town of Tblisi',
	krasnodarcenter='WPT 17\nDefensive position next to the town of Krasnodar',
	navalzone='WPT 17\nDefensive position on the sea',
	
}

local filepath = 'foothold_1.4.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)
anapa = ZoneCommander:new({zone='Anapa', side=2, level=5, upgrades=airfield, crates=cargoAccepts.anapa, flavorText=flavor.anapa})
carrier = ZoneCommander:new({zone='Carrier Group', side=2, level=2, upgrades=carrier, crates={}, flavorText=flavor.carrier})
alpha = ZoneCommander:new({zone='Alpha', side=0, level=0, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.alpha})
bravo = ZoneCommander:new({zone='Bravo', side=1, level=3, upgrades=farp, crates=cargoAccepts.bravo, flavorText=flavor.bravo})
charlie = ZoneCommander:new({zone='Charlie', side=0, level=0, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.charlie})
convoy = ZoneCommander:new({zone='Convoy', side=1, level=3, upgrades=convoy, crates=cargoAccepts.general, flavorText=flavor.convoy})
krymsk = ZoneCommander:new({zone='Krymsk', side=1, level=5, upgrades=airfield, crates=cargoAccepts.krymsk, flavorText=flavor.krymsk})
oilfields = ZoneCommander:new({zone='Oil Fields', side=1, level=3, upgrades=farp, crates=cargoAccepts.general, flavorText=flavor.oilfields, income=2})
radio = ZoneCommander:new({zone='Radio Tower', side=1, level=1, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.radio})
delta = ZoneCommander:new({zone='Delta', side=1, level=1, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.delta})
factory = ZoneCommander:new({zone='Factory', side=1, level=1, upgrades=regularzone, crates=cargoAccepts.factory, flavorText=flavor.factory, income=2})
samsite = ZoneCommander:new({zone='SAM Site', side=0, level=0, upgrades=specialSAM, crates=cargoAccepts.general, flavorText=flavor.samsite})
foxtrot = ZoneCommander:new({zone='Foxtrot', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.foxtrot})
echo = ZoneCommander:new({zone='Echo', side=1, level=3, upgrades=farp, crates=cargoAccepts.echo, flavorText=flavor.echo})
krasnodar = ZoneCommander:new({zone='Krasnodar', side=1, level=6, upgrades=specialKrasnodar, crates=cargoAccepts.general, flavorText=flavor.krasnodar, income=2})
novorossiysk = ZoneCommander:new({zone='Novorossiysk', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.novorossiysk})
gelendzhik = ZoneCommander:new({zone='Gelendzhik', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.gelendzhik})
maykop = ZoneCommander:new({zone='Maykop', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.maykop})
sochi = ZoneCommander:new({zone='Sochi', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.sochi})
gudauta = ZoneCommander:new({zone='Gudauta', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.gudauta})
sukhumi = ZoneCommander:new({zone='Sukhumi', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.sukhumi})
mineralnye = ZoneCommander:new({zone='Mineralnye', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.mineralnye})
nalchik = ZoneCommander:new({zone='Nalchik', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.nalchik})
beslan = ZoneCommander:new({zone='Beslan', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.beslan})
senaki = ZoneCommander:new({zone='Senaki', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.senaki})
kutaisi = ZoneCommander:new({zone='Kutaisi', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.kutaisi})
kobuleti = ZoneCommander:new({zone='Kobuleti', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.kobuleti})
batumi = ZoneCommander:new({zone='Batumi', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.batumi})
tblisi = ZoneCommander:new({zone='Tblisi', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.tblisi})
mozdok = ZoneCommander:new({zone='Mozdok', side=1, level=5, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.mozdok})
labinsk = ZoneCommander:new({zone='Labinsk', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.labinsk})
goryachiy = ZoneCommander:new({zone='Goryachiy', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.goryachiy})
shaumyan = ZoneCommander:new({zone='Shaumyan', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.shaumyan})
volkonka = ZoneCommander:new({zone='Volkonka', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.volkonka})
psebay = ZoneCommander:new({zone='Psebay', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.psebay})
cherkessk = ZoneCommander:new({zone='Cherkessk', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.cherkessk})
teberda = ZoneCommander:new({zone='Teberda', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.teberda})
tyrnyuaz = ZoneCommander:new({zone='Tyrnyuaz', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.tyrnyuaz})
kazbegi = ZoneCommander:new({zone='Kazbegi', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.kazbegi})
chiha = ZoneCommander:new({zone='Chiha', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.chiha})
khashuri = ZoneCommander:new({zone='Khashuri', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.khashuri})
kaspi = ZoneCommander:new({zone='Kaspi', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.kaspi})
trainingcamp= ZoneCommander:new({zone='Training Camp', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.trainingcamp})
mountainpass = ZoneCommander:new({zone='Mountain Pass', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.mountainpass})
twinlakes = ZoneCommander:new({zone='Twin Lakes', side=1, level=5, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.twinlakes})
krasnodarcenter = ZoneCommander:new({zone='Krasnodar Center', side=1, level=3, upgrades=regularzone, crates=cargoAccepts.general, flavorText=flavor.krasnodarcenter})
navalzone = ZoneCommander:new({zone='Naval Zone', side=1, level=2, upgrades=navalzone, crates=cargoAccepts.general, flavorText=flavor.navalzone})

radio:addCriticalObject('RadioTower')
psebay:addCriticalObject('RadioTower2')
samsite:addCriticalObject('CommandCenter')
factory:addCriticalObject('FactoryBuilding1')
factory:addCriticalObject('FactoryBuilding2')
mountainpass:addCriticalObject('FactoryBuilding3')
mountainpass:addCriticalObject('FactoryBuilding4')
convoy:addCriticalObject('convoy1')
convoy:addCriticalObject('convoy2')
convoy:addCriticalObject('convoy3')
convoy:addCriticalObject('convoy4')

local oilbuildings = {'oilref1','oilref2'}
for i,v in ipairs(oilbuildings) do
	oilfields:addCriticalObject(v)
end

dispatch = {
	krymsk = {
		GroupCommander:new({name='krym1', mission='supply', targetzone='Bravo'}),
		GroupCommander:new({name='krym2', mission='attack', targetzone='Bravo'}),
		GroupCommander:new({name='krym3', mission='patrol', targetzone='Bravo'}),
		GroupCommander:new({name='krym4', mission='patrol', targetzone='Krymsk'}),
		GroupCommander:new({name='krym5', mission='supply', targetzone='Radio Tower'}),
		GroupCommander:new({name='krym6', mission='attack', targetzone='Radio Tower'}),
		GroupCommander:new({name='krym7', mission='patrol', targetzone='Radio Tower'}),
		GroupCommander:new({name='krym8', mission='patrol', targetzone='Bravo'}),
		GroupCommander:new({name='krym9', mission='patrol', targetzone='Krymsk'}),
		GroupCommander:new({name='krym10', mission='supply', targetzone='Bravo'}),
		GroupCommander:new({name='krym11', mission='supply', targetzone='Radio Tower'}),
		GroupCommander:new({name='krym12', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='krym13', mission='attack', targetzone='Delta'}),
		GroupCommander:new({name='krym14', mission='supply', targetzone='Factory'}),
		GroupCommander:new({name='krym15', mission='attack', targetzone='Factory'}),
		GroupCommander:new({name='krym16', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='krym17', mission='supply', targetzone='Factory'}),
		GroupCommander:new({name='krym18', mission='supply', targetzone='SAM Site'}),
		GroupCommander:new({name='krym19', mission='supply', targetzone='SAM Site'}),
		GroupCommander:new({name='krym20', mission='attack', targetzone='SAM Site'}),
		GroupCommander:new({name='krym21', mission='patrol', targetzone='Delta'}),
		GroupCommander:new({name='krym22', mission='supply', targetzone='Oil Fields'}),
		GroupCommander:new({name='krym23', mission='supply', targetzone='Oil Fields'}),
		GroupCommander:new({name='krymsk-supply-1', mission='supply', targetzone='Novorossiysk'}),
		GroupCommander:new({name='krymsk-supply-2', mission='supply', targetzone='Novorossiysk'}),
		GroupCommander:new({name='krym24', mission='attack', targetzone='Oil Fields'}),
		GroupCommander:new({name='krym25', mission='attack', targetzone='Bravo', type='surface'})
	},
	bravo = {
		GroupCommander:new({name='bravo1', mission='supply', targetzone='Alpha'}),
		GroupCommander:new({name='bravo2', mission='attack', targetzone='Alpha'}),
		GroupCommander:new({name='bravo6', mission='supply', targetzone='Charlie'}),
		GroupCommander:new({name='bravo7', mission='attack', targetzone='Charlie'}),
		GroupCommander:new({name='bravo4', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='bravo5', mission='attack', targetzone='Krymsk'}),
		GroupCommander:new({name='bravo8', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='bravo10', mission='supply', targetzone='Charlie'}),
		GroupCommander:new({name='bravo9', mission='supply', targetzone='Alpha'}),
		GroupCommander:new({name='bravo11', mission='supply', targetzone='Oil Fields'}),
		GroupCommander:new({name='bravo12', mission='supply', targetzone='Oil Fields'}),
		GroupCommander:new({name='bravo13', mission='attack', targetzone='Oil Fields'}),
		GroupCommander:new({name='bravo14', mission='supply', targetzone='Convoy', type='surface'})
	},
	anapa = {
		GroupCommander:new({name='anapa1', mission='supply', targetzone='Alpha'}),
		GroupCommander:new({name='anapa3', mission='supply', targetzone='Bravo'}),
		GroupCommander:new({name='anapa2', mission='supply', targetzone='Charlie'}),
		GroupCommander:new({name='anapa5', mission='patrol', targetzone='Bravo'}),
		GroupCommander:new({name='anapa-tanker-drogue', mission='patrol', targetzone='Maykop'}),
		GroupCommander:new({name='anapa-tanker', mission='patrol', targetzone='Maykop'})
	},
	charlie={
		GroupCommander:new({name='anapa6', mission='attack', targetzone='Bravo'})
	},
	factory={
		GroupCommander:new({name='factory1', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='factory2', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='factory3', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='factory4', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='factory5', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='factory6', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='factory7', mission='supply', targetzone='Echo'}),
		GroupCommander:new({name='factory8', mission='supply', targetzone='Echo'}),
		GroupCommander:new({name='factory-krymsk-supply', mission='supply', targetzone='Krymsk', type='surface'}),
		GroupCommander:new({name='factory-delta-supply', mission='supply', targetzone='Delta', type='surface'}),
		GroupCommander:new({name='factory-echo-supply', mission='supply', targetzone='Echo', type='surface'}),
		GroupCommander:new({name='factory-foxtrot-supply', mission='supply', targetzone='Foxtrot', type='surface'})
	},
	echo={
		GroupCommander:new({name='echo1', mission='supply', targetzone='SAM Site'}),
		GroupCommander:new({name='echo2', mission='supply', targetzone='SAM Site'}),
		GroupCommander:new({name='echo3', mission='attack', targetzone='Delta'}),
		GroupCommander:new({name='echo4', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='echo5', mission='supply', targetzone='Delta'}),
		GroupCommander:new({name='echo6', mission='supply', targetzone='Factory'}),
		GroupCommander:new({name='echo7', mission='supply', targetzone='Factory'}),
		GroupCommander:new({name='echo8', mission='attack', targetzone='Factory'}),
		GroupCommander:new({name='echo9', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='echo10', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='echo11', mission='attack', targetzone='Foxtrot'}),
		GroupCommander:new({name='echo12', mission='supply', targetzone='Krasnodar'}),
		GroupCommander:new({name='echo13', mission='supply', targetzone='Krasnodar'}),
		GroupCommander:new({name='echo14', mission='supply', targetzone='Krasnodar'})
	},
	krasnodar={
		GroupCommander:new({name='kras1', mission='supply', targetzone='Echo'}),
		GroupCommander:new({name='kras2', mission='supply', targetzone='Echo'}),
		GroupCommander:new({name='kras3', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='kras4', mission='supply', targetzone='Foxtrot'}),
		GroupCommander:new({name='krasnodar-supply-1', mission='supply', targetzone='Labinsk'}),
		GroupCommander:new({name='krasnodar-supply-2', mission='supply', targetzone='Labinsk'}),
		GroupCommander:new({name='krasnodar-supply-3', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='krasnodar-supply-4', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='krasnodar-supply-5', mission='supply', targetzone='Goryachiy', type='surface'}),
		GroupCommander:new({name='kras5', mission='attack', targetzone='SAM Site'}),
		GroupCommander:new({name='kras6', mission='attack', targetzone='Krymsk'}),
		GroupCommander:new({name='kras7', mission='attack', targetzone='Radio Tower'}),
		GroupCommander:new({name='kras8', mission='attack', targetzone='Factory'}),
		GroupCommander:new({name='kras9', mission='attack', targetzone='Echo'}),
		GroupCommander:new({name='kras10', mission='attack', targetzone='Foxtrot'}),
		GroupCommander:new({name='kras11', mission='patrol', targetzone='Echo'}),
		GroupCommander:new({name='kras12', mission='patrol', targetzone='Delta'}),
		GroupCommander:new({name='kras13', mission='patrol', targetzone='Factory'})
	},
	foxtrot={
		GroupCommander:new({name='foxtrot-krymsk-attack', mission='attack', targetzone='Krymsk', type='surface'}),
		GroupCommander:new({name='foxtrot-echo-attack', mission='attack', targetzone='Echo', type='surface'})
	},
	goryachiy={
		GroupCommander:new({name='goryachiy-supply-1', mission='supply', targetzone='Shaumyan', type='surface'}),
		GroupCommander:new({name='goryachiy-supply-2', mission='supply', targetzone='Maykop', type='surface'}),
		GroupCommander:new({name='goryachiy-supply-3', mission='supply', targetzone='Krasnodar', type='surface'})
	},
	oilfields={
		GroupCommander:new({name='oil-krymsk-supply', mission='supply', targetzone='Krymsk', type='surface'})
	},
	carrier={
		GroupCommander:new({name='carrier-supply-1', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='carrier-supply-2', mission='supply', targetzone='Batumi'}),
		GroupCommander:new({name='carrier-tanker', mission='patrol', targetzone='Khashuri'})
	},
	batumi={
		GroupCommander:new({name='batumi-supply-1', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='batumi-supply-2', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='batumi-supply-3', mission='supply', targetzone='Mountain Pass'}),
		GroupCommander:new({name='batumi-supply-4', mission='supply', targetzone='Mountain Pass'}),
		GroupCommander:new({name='batumi-attack-1', mission='attack', targetzone='Kobuleti'}),
		GroupCommander:new({name='batumi-attack-2', mission='attack', targetzone='Mountain Pass'}),
		GroupCommander:new({name='batumi-patrol-1', mission='patrol', targetzone='Batumi'})
	},
	gelendzhik={
		GroupCommander:new({name='gelendzhik-supply-1', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='gelendzhik-supply-2', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='gelendzhik-supply-3', mission='supply', targetzone='Novorossiysk'}),
		GroupCommander:new({name='gelendzhik-supply-4', mission='supply', targetzone='Novorossiysk'}),
		GroupCommander:new({name='gelendzhik-attack-1', mission='attack', targetzone='Goryachiy'}),
		GroupCommander:new({name='gelendzhik-attack-2', mission='attack', targetzone='Novorossiysk'}),
		GroupCommander:new({name='gelendzhik-supply-5', mission='supply', targetzone='Novorossiysk', type='surface'}),
		GroupCommander:new({name='gelendzhik-supply-6', mission='supply', targetzone='Naval Zone', type='surface'})
	},
	novorossiysk={
		GroupCommander:new({name='novorossiysk-supply-1', mission='supply', targetzone='Gelendzhik'}),
		GroupCommander:new({name='novorossiysk-supply-2', mission='supply', targetzone='Gelendzhik'}),
		GroupCommander:new({name='novorossiysk-supply-4', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='novorossiysk-supply-5', mission='supply', targetzone='Krymsk'}),
		GroupCommander:new({name='novorossiysk-supply-3', mission='supply', targetzone='Gelendzhik', type='surface'}),
		GroupCommander:new({name='novorossiysk-patrol-1', mission='patrol', targetzone='Novorossiysk'})
	},
	kobuleti={
		GroupCommander:new({name='kobuleti-supply-1', mission='supply', targetzone='Batumi'}),
		GroupCommander:new({name='kobuleti-supply-2', mission='supply', targetzone='Batumi'}),
		GroupCommander:new({name='kobuleti-supply-3', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='kobuleti-supply-4', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='kobuleti-supply-5', mission='supply', targetzone='Kutaisi'}),
		GroupCommander:new({name='kobuleti-supply-6', mission='supply', targetzone='Kutaisi'}),
		GroupCommander:new({name='kobuleti-attack-1', mission='attack', targetzone='Batumi'}),
		GroupCommander:new({name='kobuleti-attack-2', mission='attack', targetzone='Senaki'}),
		GroupCommander:new({name='kobuleti-attack-3', mission='attack', targetzone='Kutaisi'})
	},
	kutaisi={
		GroupCommander:new({name='kutaisi-supply-1', mission='supply', targetzone='Chiha'}),
		GroupCommander:new({name='kutaisi-supply-2', mission='supply', targetzone='Chiha'}),
		GroupCommander:new({name='kutaisi-supply-3', mission='supply', targetzone='Khashuri'}),
		GroupCommander:new({name='kutaisi-supply-4', mission='supply', targetzone='Khashuri'}),
		GroupCommander:new({name='kutaisi-supply-5', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='kutaisi-supply-6', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='kutaisi-supply-7', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='kutaisi-supply-8', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='kutaisi-attack-1', mission='attack', targetzone='Chiha'}),
		GroupCommander:new({name='kutaisi-attack-2', mission='attack', targetzone='Khashuri'}),
		GroupCommander:new({name='kutaisi-attack-3', mission='attack', targetzone='Senaki'}),
		GroupCommander:new({name='kutaisi-attack-4', mission='attack', targetzone='Kobuleti'}),
		GroupCommander:new({name='kutaisi-patrol-1', mission='patrol', targetzone='Kutaisi'})
	},
	tblisi={
		GroupCommander:new({name='tblisi-supply-1', mission='supply', targetzone='Twin Lakes'}),
		GroupCommander:new({name='tblisi-supply-2', mission='supply', targetzone='Twin Lakes'}),
		GroupCommander:new({name='tblisi-supply-3', mission='supply', targetzone='Kaspi'}),
		GroupCommander:new({name='tblisi-supply-4', mission='supply', targetzone='Kaspi'}),
		GroupCommander:new({name='tblisi-supply-5', mission='supply', targetzone='Training Camp'}),
		GroupCommander:new({name='tblisi-supply-6', mission='supply', targetzone='Training Camp'}),
		GroupCommander:new({name='tblisi-supply-7', mission='supply', targetzone='Kazbegi'}),
		GroupCommander:new({name='tblisi-supply-8', mission='supply', targetzone='Kazbegi'}),
		GroupCommander:new({name='tblisi-supply-9', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='tblisi-supply-10', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='tblisi-supply-11', mission='supply', targetzone='Kaspi', type='surface'}),
		GroupCommander:new({name='tblisi-supply-12', mission='supply', targetzone='Khashuri', type='surface'}),
		GroupCommander:new({name='tblisi-attack-1', mission='attack', targetzone='Twin Lakes'}),
		GroupCommander:new({name='tblisi-attack-2', mission='attack', targetzone='Kaspi'}),
		GroupCommander:new({name='tblisi-attack-3', mission='attack', targetzone='Training Camp'}),
		GroupCommander:new({name='tblisi-attack-4', mission='attack', targetzone='Kazbegi'}),
		GroupCommander:new({name='tblisi-attack-5', mission='attack', targetzone='Beslan'}),
		GroupCommander:new({name='tblisi-attack-6', mission='attack', targetzone='Carrier Group'}),
		GroupCommander:new({name='tblisi-patrol-1', mission='patrol', targetzone='Tblisi'})
	},
	maykop={
		GroupCommander:new({name='maykop-supply-1', mission='supply', targetzone='Labinsk'}),
		GroupCommander:new({name='maykop-supply-2', mission='supply', targetzone='Labinsk'}),
		GroupCommander:new({name='maykop-supply-3', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='maykop-supply-4', mission='supply', targetzone='Goryachiy'}),
		GroupCommander:new({name='maykop-supply-5', mission='supply', targetzone='Goryachiy', type='surface'}),
		GroupCommander:new({name='maykop-supply-6', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='maykop-supply-7', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='maykop-supply-8', mission='supply', targetzone='Psebay', type='surface'}),
		GroupCommander:new({name='maykop-supply-9', mission='supply', targetzone='Shaumyan'}),
		GroupCommander:new({name='maykop-supply-10', mission='supply', targetzone='Shaumyan'}),
		GroupCommander:new({name='maykop-attack-1', mission='attack', targetzone='Labinsk'}),
		GroupCommander:new({name='maykop-attack-2', mission='attack', targetzone='Goryachiy'}),
		GroupCommander:new({name='maykop-attack-3', mission='attack', targetzone='Psebay'}),
		GroupCommander:new({name='maykop-attack-4', mission='attack', targetzone='Shaumyan'}),
		GroupCommander:new({name='maykop-patrol-1', mission='patrol', targetzone='Maykop'})
	},
	senaki={
		GroupCommander:new({name='senaki-supply-1', mission='supply', targetzone='Kutaisi'}),
		GroupCommander:new({name='senaki-supply-2', mission='supply', targetzone='Kutaisi'}),
		GroupCommander:new({name='senaki-supply-3', mission='supply', targetzone='Kutaisi', type='surface'}),
		GroupCommander:new({name='senaki-supply-4', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='senaki-supply-5', mission='supply', targetzone='Kobuleti'}),
		GroupCommander:new({name='senaki-supply-6', mission='supply', targetzone='Kobuleti', type='surface'}),
		GroupCommander:new({name='senaki-supply-7', mission='supply', targetzone='Sukhumi'}),
		GroupCommander:new({name='senaki-supply-8', mission='supply', targetzone='Sukhumi'}),
		GroupCommander:new({name='senaki-attack-1', mission='attack', targetzone='Kutaisi'}),
		GroupCommander:new({name='senaki-attack-2', mission='attack', targetzone='Kobuleti'}),
		GroupCommander:new({name='senaki-attack-3', mission='attack', targetzone='Sukhumi'})
	},
	sochi={
		GroupCommander:new({name='sochi-supply-1', mission='supply', targetzone='Volkonka'}),
		GroupCommander:new({name='sochi-supply-2', mission='supply', targetzone='Volkonka'}),
		GroupCommander:new({name='sochi-supply-3', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='sochi-supply-4', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='sochi-supply-5', mission='supply', targetzone='Gudauta'}),
		GroupCommander:new({name='sochi-supply-6', mission='supply', targetzone='Gudauta'}),
		GroupCommander:new({name='sochi-supply-7', mission='supply', targetzone='Volkonka', type='surface'}),
		GroupCommander:new({name='sochi-supply-8', mission='supply', targetzone='Gudauta', type='surface'}),
		GroupCommander:new({name='sochi-attack-1', mission='attack', targetzone='Volkonka'}),
		GroupCommander:new({name='sochi-attack-2', mission='attack', targetzone='Gudauta'}),
		GroupCommander:new({name='sochi-attack-3', mission='attack', targetzone='Senaki'}),
		GroupCommander:new({name='sochi-patrol-1', mission='patrol', targetzone='Sochi'})
	},
	gudauta={
		GroupCommander:new({name='gudauta-supply-1', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='gudauta-supply-2', mission='supply', targetzone='Psebay'}),
		GroupCommander:new({name='gudauta-supply-3', mission='supply', targetzone='Teberda'}),
		GroupCommander:new({name='gudauta-supply-4', mission='supply', targetzone='Teberda'}),
		GroupCommander:new({name='gudauta-supply-5', mission='supply', targetzone='Sukhumi'}),
		GroupCommander:new({name='gudauta-supply-6', mission='supply', targetzone='Sukhumi'}),
		GroupCommander:new({name='gudauta-supply-7', mission='supply', targetzone='Sochi'}),
		GroupCommander:new({name='gudauta-supply-8', mission='supply', targetzone='Sochi'}),	
		GroupCommander:new({name='gudauta-supply-9', mission='supply', targetzone='Sukhumi', type='surface'}),
		GroupCommander:new({name='gudauta-supply-10', mission='supply', targetzone='Sochi', type='surface'}),
		GroupCommander:new({name='gudauta-attack-1', mission='attack', targetzone='Sochi'}),
		GroupCommander:new({name='gudauta-attack-2', mission='attack', targetzone='Sukhumi'})
	},
	nalchik={
		GroupCommander:new({name='nalchik-supply-1', mission='supply', targetzone='Tyrnyuaz', type='surface'}),
		GroupCommander:new({name='nalchik-supply-2', mission='supply', targetzone='Mozdok', type='surface'}),
		GroupCommander:new({name='nalchik-supply-3', mission='supply', targetzone='Tyrnyuaz'}),
		GroupCommander:new({name='nalchik-supply-4', mission='supply', targetzone='Tyrnyuaz'}),
		GroupCommander:new({name='nalchik-supply-5', mission='supply', targetzone='Mineralnye'}),
		GroupCommander:new({name='nalchik-supply-6', mission='supply', targetzone='Mineralnye'}),
		GroupCommander:new({name='nalchik-supply-7', mission='supply', targetzone='Mozdok'}),
		GroupCommander:new({name='nalchik-supply-8', mission='supply', targetzone='Mozdok'}),	
		GroupCommander:new({name='nalchik-supply-9', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='nalchik-supply-10', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='nalchik-attack-1', mission='attack', targetzone='Mineralnye'}),
		GroupCommander:new({name='nalchik-attack-2', mission='attack', targetzone='Beslan'})
	},
	beslan={
		GroupCommander:new({name='beslan-supply-1', mission='supply', targetzone='Tblisi'}),
		GroupCommander:new({name='beslan-supply-2', mission='supply', targetzone='Tblisi'}),
		GroupCommander:new({name='beslan-supply-3', mission='supply', targetzone='Kazbegi'}),
		GroupCommander:new({name='beslan-supply-4', mission='supply', targetzone='Kazbegi'}),
		GroupCommander:new({name='beslan-supply-5', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='beslan-supply-6', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='beslan-supply-7', mission='supply', targetzone='Mozdok'}),
		GroupCommander:new({name='beslan-supply-8', mission='supply', targetzone='Mozdok'}),	
		GroupCommander:new({name='beslan-attack-1', mission='attack', targetzone='Tblisi'}),
		GroupCommander:new({name='beslan-attack-2', mission='attack', targetzone='Kazbegi'}),
		GroupCommander:new({name='beslan-attack-3', mission='attack', targetzone='Nalchik'})
	},
	mozdok={
		GroupCommander:new({name='mozdok-supply-1', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='mozdok-supply-2', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='mozdok-supply-3', mission='supply', targetzone='Nalchik', type='surface'}),
		GroupCommander:new({name='mozdok-supply-4', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='mozdok-supply-5', mission='supply', targetzone='Beslan'}),
		GroupCommander:new({name='mozdok-supply-6', mission='supply', targetzone='Beslan', type='surface'}),
		GroupCommander:new({name='mozdok-patrol-1', mission='patrol', targetzone='Mozdok'}),
		GroupCommander:new({name='mozdok-attack-1', mission='attack', targetzone='Nalchik'}),
		GroupCommander:new({name='mozdok-attack-2', mission='attack', targetzone='Beslan'}),
		GroupCommander:new({name='mozdok-attack-3', mission='attack', targetzone='Nalchik', type='surface'})
	},
	mineralnye={
		GroupCommander:new({name='mineralnye-supply-1', mission='supply', targetzone='Cherkessk'}),
		GroupCommander:new({name='mineralnye-supply-2', mission='supply', targetzone='Cherkessk'}),
		GroupCommander:new({name='mineralnye-supply-3', mission='supply', targetzone='Cherkessk', type='surface'}),
		GroupCommander:new({name='mineralnye-supply-4', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='mineralnye-supply-5', mission='supply', targetzone='Nalchik'}),
		GroupCommander:new({name='mineralnye-supply-6', mission='supply', targetzone='Nalchik', type='surface'}),
		GroupCommander:new({name='mineralnye-attack-1', mission='attack', targetzone='Cherkessk'}),
		GroupCommander:new({name='mineralnye-attack-2', mission='attack', targetzone='Nalchik'})
	},
	mountainpass={
		GroupCommander:new({name='mountainpass-supply-1', mission='supply', targetzone='Batumi'}),
		GroupCommander:new({name='mountainpass-attack-1', mission='attack', targetzone='Batumi'})
	},
	cherkessk={
		GroupCommander:new({name='cherkessk-supply-1', mission='supply', targetzone='Psebay', type='surface'}),
		GroupCommander:new({name='cherkessk-supply-2', mission='supply', targetzone='Teberda', type='surface'}),
		GroupCommander:new({name='cherkessk-supply-3', mission='supply', targetzone='Mineralnye', type='surface'}),
	},
	sukhumi={
		GroupCommander:new({name='sukhumi-supply-1', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='sukhumi-supply-2', mission='supply', targetzone='Senaki'}),
		GroupCommander:new({name='sukhumi-supply-3', mission='supply', targetzone='Gudauta'}),
		GroupCommander:new({name='sukhumi-supply-4', mission='supply', targetzone='Gudauta'}),
		GroupCommander:new({name='sukhumi-supply-5', mission='supply', targetzone='Senaki', type='surface'}),
		GroupCommander:new({name='sukhumi-attack-1', mission='attack', targetzone='Senaki'}),
		GroupCommander:new({name='sukhumi-attack-2', mission='attack', targetzone='Gudauta'})
	},
	volkonka={
		GroupCommander:new({name='volkonka-supply-1', mission='supply', targetzone='Sochi', type='surface'}),
		GroupCommander:new({name='volkonka-supply-2', mission='supply', targetzone='Shaumyan', type='surface'}),
			}
}

anapa:addGroups(dispatch.anapa)
bravo:addGroups(dispatch.bravo)
krymsk:addGroups(dispatch.krymsk)
charlie:addGroups(dispatch.charlie)
factory:addGroups(dispatch.factory)
echo:addGroups(dispatch.echo)
krasnodar:addGroups(dispatch.krasnodar)
foxtrot:addGroups(dispatch.foxtrot)
oilfields:addGroups(dispatch.oilfields)
novorossiysk:addGroups(dispatch.novorossiysk)
gelendzhik:addGroups(dispatch.gelendzhik)
goryachiy:addGroups(dispatch.goryachiy)
maykop:addGroups(dispatch.maykop)
--shaumyan:addGroups(dispatch.shaumyan)
volkonka:addGroups(dispatch.volkonka)
--psebay:addGroups(dispatch.psebay)
sochi:addGroups(dispatch.sochi)
gudauta:addGroups(dispatch.gudauta)
sukhumi:addGroups(dispatch.sukhumi)
--teberda:addGroups(dispatch.teberda)
cherkessk:addGroups(dispatch.cherkessk)
mineralnye:addGroups(dispatch.mineralnye)
nalchik:addGroups(dispatch.nalchik)
mozdok:addGroups(dispatch.mozdok)
beslan:addGroups(dispatch.beslan)
--tyrnyuaz:addGroups(dispatch.tyrnyuaz)
sukhumi:addGroups(dispatch.sukhumi)
--kazbegi:addGroups(dispatch.kazbegi)
--chiha:addGroups(dispatch.chiha)
batumi:addGroups(dispatch.batumi)
kobuleti:addGroups(dispatch.kobuleti)
senaki:addGroups(dispatch.senaki)
mountainpass:addGroups(dispatch.mountainpass)
kutaisi:addGroups(dispatch.kutaisi)
--khashuri:addGroups(dispatch.khashuri)
--twinlakes:addGroups(dispatch.twinlakes)
--trainingcamp:addGroups(dispatch.trainingcamp)
--kaspi:addGroups(dispatch.kaspi)
tblisi:addGroups(dispatch.tblisi)


bc:addZone(anapa)
bc:addZone(carrier)
bc:addZone(alpha)
bc:addZone(bravo)
bc:addZone(charlie)
bc:addZone(convoy)
bc:addZone(krymsk)
bc:addZone(oilfields)
bc:addZone(radio)
bc:addZone(delta)
bc:addZone(factory)
bc:addZone(samsite)
bc:addZone(foxtrot)
bc:addZone(echo)
bc:addZone(krasnodar)
bc:addZone(novorossiysk)
bc:addZone(sochi)
bc:addZone(maykop)
bc:addZone(gudauta)
bc:addZone(sukhumi)
bc:addZone(mineralnye)
bc:addZone(nalchik)
bc:addZone(mozdok)
bc:addZone(beslan)
bc:addZone(tblisi)
bc:addZone(senaki)
bc:addZone(kutaisi)
bc:addZone(kobuleti)
bc:addZone(batumi)
bc:addZone(gelendzhik)
bc:addZone(labinsk)
bc:addZone(goryachiy)
bc:addZone(cherkessk)
bc:addZone(psebay)
bc:addZone(volkonka)
bc:addZone(tyrnyuaz)
bc:addZone(mountainpass)
bc:addZone(chiha)
bc:addZone(twinlakes)
bc:addZone(kaspi)
bc:addZone(trainingcamp)
bc:addZone(shaumyan)
bc:addZone(teberda)
bc:addZone(kazbegi)
bc:addZone(krasnodarcenter)
bc:addZone(navalzone)
bc:addZone(khashuri)

bc:addConnection("Anapa","Alpha")
bc:addConnection("Alpha","Bravo")
bc:addConnection("Bravo","Krymsk")
bc:addConnection("Bravo","Charlie")
bc:addConnection("Bravo","Convoy")
bc:addConnection("Anapa","Charlie")
bc:addConnection("Bravo","Oil Fields")
bc:addConnection("Krymsk","Oil Fields")
bc:addConnection("Krymsk","Radio Tower")
bc:addConnection("Krymsk","Factory")
bc:addConnection("Krymsk","Delta")
bc:addConnection("Krymsk","Novorossiysk")
bc:addConnection("Factory","Delta")
bc:addConnection("Factory","Foxtrot")
bc:addConnection("Factory","Echo")
bc:addConnection("Delta","Echo")
bc:addConnection("Foxtrot","Krasnodar")
bc:addConnection("Echo","Krasnodar")
bc:addConnection("Echo","SAM Site")
bc:addConnection("Krymsk","SAM Site")
bc:addConnection("Krasnodar","Labinsk")
bc:addConnection("Maykop","Labinsk")
bc:addConnection("Krasnodar","Goryachiy")
bc:addConnection("Novorossiysk","Gelendzhik")
bc:addConnection("Naval Zone","Gelendzhik")
bc:addConnection("Goryachiy","Gelendzhik")
bc:addConnection("Goryachiy","Maykop")
bc:addConnection("Goryachiy","Shaumyan")
bc:addConnection("Maykop","Shaumyan")
bc:addConnection("Maykop","Psebay")
bc:addConnection("Shaumyan","Volkonka")
bc:addConnection("Sochi","Volkonka")
bc:addConnection("Sochi","Psebay")
bc:addConnection("Sochi","Gudauta")
bc:addConnection("Gudauta","Psebay")
bc:addConnection("Gudauta","Teberda")
bc:addConnection("Gudauta","Sukhumi")
bc:addConnection("Teberda","Sukhumi")
bc:addConnection("Cherkessk","Psebay")
bc:addConnection("Cherkessk","Mineralnye")
bc:addConnection("Nalchik","Mineralnye")
bc:addConnection("Nalchik","Tyrnyuaz")
bc:addConnection("Nalchik","Mozdok")
bc:addConnection("Nalchik","Beslan")
bc:addConnection("Mozdok","Beslan")
bc:addConnection("Kazbegi","Beslan")
bc:addConnection("Tblisi","Beslan")
bc:addConnection("Tblisi","Kaspi")
bc:addConnection("Kutaisi","Kobuleti")
bc:addConnection("Tblisi","Training Camp")
bc:addConnection("Tblisi","Twin Lakes")
bc:addConnection("Khashuri","Kaspi")
bc:addConnection("Khashuri","Kutaisi")
bc:addConnection("Chiha","Kutaisi")
bc:addConnection("Senaki","Kutaisi")
bc:addConnection("Senaki","Kobuleti")
bc:addConnection("Senaki","Carrier Group")
bc:addConnection("Senaki","Sukhumi")
bc:addConnection("Carrier Group","Batumi")
bc:addConnection("Batumi","Kobuleti")
bc:addConnection("Mountain Pass","Batumi")
bc:addConnection("Mountain Pass","Twin Lakes")
bc:addConnection("Teberda","Sukhumi")
bc:addConnection("Senaki","Sukhumi")


convoy:registerTrigger('lost', function (event, sender)
	local convoyItems = {'convoy1','convoy2','convoy3', 'convoy4'}
	
	local message = "Convoy liberated"
	local totalLost = 0
	for i,v in ipairs(convoyItems) do
		if not StaticObject.getByName(v) then
			totalLost = totalLost+1
		end
	end
	
	if totalLost>0 then
		local percentLost = math.ceil((totalLost/#convoyItems)*100)
		percentLost = math.min(percentLost,100)
		percentLost = math.max(percentLost,1)
		message = message..' but we lost '..percentLost..'% of the trucks.'
	else
		message = message..'. We recovered all of the supplies.'
	end
	
	local creditsEarned = (#convoyItems - totalLost) * 250
	message = message..'\n\n+'..creditsEarned..' credits'
	
	bc:addFunds(2, creditsEarned)
	
	trigger.action.outTextForCoalition(2, message, 15)
end, 'convoyLost', 1)

local showCredIncrease = function(event, sender)
	trigger.action.outTextForCoalition(sender.side, '+'..math.floor(sender.income*360)..' Credits/Hour', 5)
end

oilfields:registerTrigger('captured', showCredIncrease, 'oilfieldcaptured')
factory:registerTrigger('captured', showCredIncrease, 'factorycaptured')

krymsk:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('Krymsk')
	if kr.side == 1 then
		local krforces = { 'krymsk-gforce-1','krymsk-gforce-2','krymsk-gforce-3','krymsk-tforce-1' }
		for _,v in ipairs(krforces) do
			local g = Group.getByName(v)
			if g then
				g:destroy()
			end
		end
	end
end, 'krymskcaptured')

local checkMissionComplete = function (event, sender)
	local done = true
	for i,v in ipairs(bc:getZones()) do
		if v.side == 1 then
			done = false
			break
		end
	end
	
	if done then
		trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
	end
end

for i,v in ipairs(bc:getZones()) do
	v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end

--bc:addFunds(1,0)
--bc:addFunds(2,0)

Group.getByName('sead1'):destroy()
local seadTargetMenu = nil
bc:registerShopItem('sead', 'F/A-18C SEAD mission', 250, function(sender) 
	local gr = Group.getByName('sead1')
	if Utils.isGroupActive(gr) then 
		return 'SEAD mission still in progress'
	end
	mist.respawnGroup('sead1', true)
	
	if seadTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if Group.getByName('sead1') then
			local err = bc:engageZone(target, 'sead1')
			if err then
				return err
			end
			
			trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at '..target, 15)
		else
			trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
		end
		
		seadTargetMenu = nil
	end
	
	seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'F/A-18C Hornets on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('sead1')
		if Utils.isGroupActive(gr) then 
			return 'SEAD mission still in progress'
		end
		
		mist.respawnGroup('sead1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('sead1') then
				local err = bc:engageZone(target, 'sead1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)

Group.getByName('sweep1'):destroy()
bc:registerShopItem('sweepnorth', 'F-14B Fighter Sweep (North)', 150, function(sender) 
	local gr = Group.getByName('sweep1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep1', true)
end,
function (sender, params)
	local gr = Group.getByName('sweep1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep1', true)
end)

Group.getByName('sweep2'):destroy()
bc:registerShopItem('sweepsouth', 'F-15c Fighter Sweep (South)', 150, function(sender) 
	local gr = Group.getByName('sweep1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep2', true)
end,
function (sender, params)
	local gr = Group.getByName('sweep2')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep2', true)
end)

Group.getByName('cas1'):destroy()
local casTargetMenu = nil
bc:registerShopItem('cas', 'F-16 Ground Attack', 400, function(sender) 
	local gr = Group.getByName('cas1')
	if Utils.isGroupActive(gr) then 
		return 'Ground attack mission still in progress'
	end
	
	mist.respawnGroup('cas1', true)
	
	if casTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if casTargetMenu then
			if Group.getByName('cas1') then
				local err = bc:engageZone(target, 'cas1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F-16 Phantoms engaging groups at '..target, 15)
			else
				trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
			end
			
			casTargetMenu = nil
		end
	end
	
	casTargetMenu = bc:showTargetZoneMenu(2, 'F-16 Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'F-16 Phantoms on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('cas1')
		if Utils.isGroupActive(gr) then 
			return 'Ground attack mission still in progress'
		end
		
		mist.respawnGroup('cas1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('cas1') then
				local err = bc:engageZone(target, 'cas1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F-16 Phantoms engaging groups at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)

bc:addMonitoredROE('cruise1')
local cruiseMissileTargetMenu = nil
bc:registerShopItem('cruisemsl', 'Cruise Missile Strike', 800, function(sender)
	if cruiseMissileTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if cruiseMissileTargetMenu then
			local err = bc:fireAtZone(target, 'cruise1', true, 8)
			if err then
				return err
			end
			
			cruiseMissileTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..target, 15)
		end
	end
	
	cruiseMissileTargetMenu = bc:showTargetZoneMenu(2, 'Cruise Missile Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Cruise missiles ready. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local err = bc:fireAtZone(params.zone.zone, 'cruise1', true, 8)
		if err then
			return err
		end
		
		trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply friendly Zone', 200, function(sender)
	if upgradeMenu then
		return 'Choose zone from F10 menu'
	end
	
	local upgradeZone = function(target)
		if upgradeMenu then
			local zn = bc:getZoneByName(target)
			if zn and zn.side==2 then
				zn:upgrade()
			else
				return 'Zone not friendly'
			end
			
			upgradeMenu = nil
		end
	end
	
	upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply', upgradeZone, 2)
	
	trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		params.zone:upgrade()
	else
		return 'Can only target friendly zone'
	end
end)

Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'MQ-1A Predator JTAC mission', 100, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC', spawnAndOrbit, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)


local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local spawnAwacs = function(sender) 
	local gr = Group.getByName('awacs1')
	if Utils.isGroupActive(gr) then 
		return 'Darkstar still active on 252.00 MHz AM'
	end
	mist.respawnGroup('awacs1', true)
	trigger.action.outTextForCoalition(2,'Darkstar active on 252.00 MHz AM',15)
end
Group.getByName('awacs1'):destroy()
bc:registerShopItem('awacs', 'AWACS', 100, spawnAwacs, spawnAwacs)

Group.getByName('ewAircraft'):destroy()
local jamMenu = nil
bc:registerShopItem('jam', 'Jam radars at zone', 500, function(sender)
	local gr = Group.getByName('ewAircraft')
	if Utils.isGroupActive(gr) then 
		return 'Jamming mission still in progress'
	end
	
	mist.respawnGroup('ewAircraft', true)
	
	if jamMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local startJam = function(target)
		if jamMenu then
			bc:jamRadarsAtZone('ewAircraft', target)
			jamMenu = nil
			trigger.action.outTextForCoalition(2, 'Growler jamming radars at '..target, 15)
		end
	end
	
	jamMenu = bc:showTargetZoneMenu(2, 'Jamming target', startJam, 1)
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('ewAircraft')
		if Utils.isGroupActive(gr) then 
			return 'Jamming mission still in progress'
		end
		
		mist.respawnGroup('ewAircraft', true)
		
		mist.scheduleFunction(function(target)
			local ew = Group.getByName('ewAircraft')
			if ew then
				local err = bc:jamRadarsAtZone('ewAircraft', target)
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Growler jamming radars at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
		
	else
		return 'Can only target enemy zone'
	end
end)

tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms)', 100, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone)', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms)', 100, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone)', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

bc:addShopItem(2, 'sead', -1)
bc:addShopItem(2, 'sweepnorth', -1)
bc:addShopItem(2, 'sweepsouth', -1)
bc:addShopItem(2, 'cas', -1)
bc:addShopItem(2, 'cruisemsl', 12)
bc:addShopItem(2, 'supplies', -1)
bc:addShopItem(2, 'jtac', -1)
bc:addShopItem(2, 'smoke', -1)
bc:addShopItem(2, 'jam', -1)
bc:addShopItem(2, 'awacs', -1)
bc:addShopItem(2, 'carrier-tanker', -1)

bc:addShopItem(2, 'armor', -1)
bc:addShopItem(2, 'artillery', -1)
bc:addShopItem(2, 'recon', -1)
bc:addShopItem(2, 'airdef', -1)

--red support
Group.getByName('redcas1'):destroy()
bc:registerShopItem('redcas1', 'Red Cas', 1000, function(sender) 
	local gr = Group.getByName('redcas1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcas1', true)
	trigger.action.outTextForCoalition(2,'The enemy has deployed a couple of Su-34 against our ground forces',15)
end)

Group.getByName('redcap1'):destroy()
bc:registerShopItem('redcap1', 'Red Cap', 1000, function(sender) 
	local gr = Group.getByName('redcap1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcap1', true)
	trigger.action.outTextForCoalition(2,'Enemy MiG-31 interceptors, coming in from the South-East',15)
end)

Group.getByName('redsead1'):destroy()
bc:registerShopItem('redsead1', 'Red Sead', 1000, function(sender) 
	local gr = Group.getByName('redsead1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redsead1', true)
	trigger.action.outTextForCoalition(2,'The enemy has launched an attack from the North-East on our air defenses',15)
end)

Group.getByName('redmlrs1'):destroy()
bc:registerShopItem('redmlrs1', 'spawn Red mlrs', 1000, function(sender) 
	local zn = bc:getZoneByName('Foxtrot')
	if zn.side == 1 and zn.active then
		local gr = Group.getByName('redmlrs1')
		if gr then
			local full = true
			for i,v in ipairs(gr:getUnits()) do
				for i2,v2 in ipairs(v:getAmmo()) do
					if v2.count < 3 then
						full = false
						break
					end
				end
				
				if not full then 
					break
				end
			end
			
			if full and gr:getSize()==gr:getInitialSize() then
				return 'ammo full'
			end
			
			trigger.action.outTextForCoalition(2,'The enemy has resupplied its artillery near Foxtrot',15)
		end
		
		mist.respawnGroup('redmlrs1')
		bc:removeShopItem(1,'redmlrs1fire')
		bc:addShopItem(1, 'redmlrs1fire', 3)
	else
		return 'zone not red'
	end
end)

bc:registerShopItem('redmlrs1fire', 'fire red mlrs', 200, function(sender) 
	local gr = Group.getByName('redmlrs1')
	if gr then
		local targetzones = {'Echo', 'Delta', 'SAM Site', 'Factory', 'Radio Tower', 'Krymsk'}
		local viabletargets = {}
		for i,v in ipairs(targetzones) do
			local z = bc:getZoneByName(v)
			
			if z and z.side == 2 then
				table.insert(viabletargets, v)
			end
		end

		if #viabletargets==0 then
			return 'no targets'
		end
		
		local targetzn = viabletargets[math.random(1,#viabletargets)]
		
		local err = bc:fireAtZone(targetzn, 'redmlrs1', true, 3, 6)
		
		if not err then
			trigger.action.outTextForCoalition(2,'Enemy artillery near Foxtrot has begun preparations to fire on '..targetzn,15)
		else
			return err
		end
	else
		return 'buy first'
	end
end)


Group.getByName('intercept1'):destroy()
Group.getByName('intercept2'):destroy()
local cargoDieEvent = nil
bc:registerShopItem('intercept1', 'Red intercept', 1000, function(sender) 
	local grt = Group.getByName('intercept1')
	local gre = Group.getByName('intercept2')
	if gre and gre:getSize()>0 and gre:getController():hasTask() then 
		return 'still alive'
	end
	
	if grt and grt:getSize()>0 and grt:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('intercept1', true)
	mist.respawnGroup('intercept2', true)
	
	if not cargoDieEvent then
		local cargoPlaneDied = function(event)
			if event.id==28 then
				if event.initiator and event.initiator:getCoalition()==2 and event.target and event.target.getName then
					if event.target:getName()=='intercept1' then
						trigger.action.outTextForCoalition(2,'Enemy cargo transport destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					elseif not Unit.getByName('intercept1') then
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					end
				end
			end
		end
		
		cargoDieEvent = mist.addEventHandler(cargoPlaneDied)
	end
end)

Group.getByName('escort1'):destroy()
Group.getByName('antiescort1'):destroy()
Group.getByName('antiescort2'):destroy()
bc:registerShopItem('escort1', 'Red antiescort', 1000, function(sender) 
	local gr = Group.getByName('escort1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('escort1', true)
	
	local spawnIntercept = function(groupname)
		if Group.getByName('escort1') then
			local g = Group.getByName(groupname)
			if not g then
				if math.random(1,100) > 30 then
					if math.random(1,100) > 50 then
						trigger.action.outTextForCoalition(2,'Enemy interceptor spotted heading for our cargo transport.',15)
					else
						trigger.action.outTextForCoalition(2,'The enemy has launched an intercept mission against our cargo transport',15)
					end
					mist.respawnGroup(groupname, true)
				end
			end
		end
	end
	
	local timers = {math.random(3*60,15*60), math.random(8*60,15*60)}
	mist.scheduleFunction(spawnIntercept, {'antiescort1'}, timer.getTime()+timers[1])
	mist.scheduleFunction(spawnIntercept, {'antiescort2'}, timer.getTime()+timers[2])
end)

krymskForce = {
	'krymsk-force-1',
	'krymsk-force-2',
	'krymsk-force-3',
	'krymsk-gforce-1',
	'krymsk-gforce-2',
	'krymsk-gforce-3',
	'krymsk-tforce-1',
	'krymsk-aforce-1',
	'krymsk-aforce-2',
	'krymsk-aforce-3',
}

for _,v in ipairs(krymskForce) do Group.getByName(v):destroy() end

bc:registerShopItem('krymskForce', 'Krymsk Assault', 1000, function(sender) 
	for _,v in ipairs(krymskForce) do
		local gr = Group.getByName(v)
		if gr and gr:getSize()>0 and gr:getController():hasTask() then 
			return 'still alive'
		end
	end
	
	if bc:getZoneByName('Echo').side==1 and bc:getZoneByName('Krymsk').side==2 then
		for _,v in ipairs(krymskForce) do
			mist.respawnGroup('krymsk-force-1', true)
			mist.respawnGroup('krymsk-force-2', true)
			mist.respawnGroup('krymsk-force-3', true)
			
			if bc:getZoneByName('Delta').side==1 then
				mist.respawnGroup('krymsk-tforce-1', true)
			end
			
			mist.respawnGroup('krymsk-aforce-1', true)
			mist.respawnGroup('krymsk-aforce-2', true)
			mist.respawnGroup('krymsk-aforce-3', true)
		end
	else
		return 'zone no match'
	end
end)

bc:addShopItem(1, 'redcas1', -1)
bc:addShopItem(1, 'redcap1', -1)
bc:addShopItem(1, 'redsead1', -1)
bc:addShopItem(1, 'redmlrs1', -1)
bc:addShopItem(1, 'intercept1', -1)
bc:addShopItem(1, 'escort1', -1)
bc:addShopItem(1, 'krymskForce', -1)

budgetAI = BudgetCommander:new({ battleCommander = bc, side=1, decissionFrequency=20*60, decissionVariance=10*60, skipChance = 10})
budgetAI:init()
--end red support

lc = LogisticCommander:new({battleCommander = bc, supplyZones = {'Anapa', 'Krymsk', 'Factory', 'Krasnodar', 'Bravo', 'Echo', 'Carrier Group', 'Senaki', 'Maykop', 'Tblisi', 'Batumi', 'Kobuleti', 'Kutaisi', 'Sukhumi', 'Gudauta', 'Sochi', 'Gelendzhik', 'Novorossiysk', 'Mineralnye', 'Nalchik', 'Beslan'}})
lc:init()


bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 5, ground = 15, sam = 30, airplane = 30, ship = 200, helicopter=40, crate=100, rescue = 50})

HercCargoDropSupply.init(bc)

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})

mc:trackMission({
	title = "Escort",
	description = "Friendly cargo transport has entered the airspace from the south. Protect it from the enemy.",
	messageStart = "New mission: Escort",
	messageEnd = "Mission ended: Escort",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('escort1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Intercept",
	description = "Enemy cargo transport has entered the airspace from the south. Intercept and destroy it before it escapes.",
	messageStart = "New mission: Intercept",
	messageEnd = "Mission ended: Intercept",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('intercept1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Destroy artillery",
	description = "The enemy has deployed artillery near Foxtrot. Destroy it before it has a chance to fire",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('redmlrs1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Defend Krymsk",
	description = "The enemy has launched an all out attack on Krymsk.\nDefend the airfield at all cost.",
	messageStart = "New mission: Defend Krymsk",
	messageEnd = "Mission ended: Defend Krymsk",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		for _,v in ipairs(krymskForce) do
			local gr = Group.getByName(v)
			if gr and gr:getSize()>0 and gr:getController():hasTask() then 
				return true
			end
		end
		
		return false
	end
})



resupplyTarget = nil
mc:trackMission({
	title = function() return "Resupply "..resupplyTarget end,
	description = function() return "Deliver supplies to "..resupplyTarget end,
	messageStart = function() return "New mission: Resupply "..resupplyTarget end,
	messageEnd = function() return "Mission ended: Resupply "..resupplyTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		resupplyTarget = nil
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not resupplyTarget then return false end
		
		local targetzn = bc:getZoneByName(resupplyTarget)
		return targetzn:canRecieveSupply()
	end
})

attackTarget = nil
mc:trackMission({
	title = function() return "Attack "..attackTarget end,
	description = function() return "Destroy enemy forces at "..attackTarget end,
	messageStart = function() return "New mission: Attack "..attackTarget end,
	messageEnd = function() return "Mission ended: Attack "..attackTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		attackTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not attackTarget then return false end
		
		local targetzn = bc:getZoneByName(attackTarget)
		return targetzn.side == 1
	end
})

captureTarget = nil
mc:trackMission({
	title = function() return "Capture "..captureTarget end,
	description = function() return captureTarget.." is neutral. Capture it by delivering supplies" end,
	messageStart = function() return "New mission: Capture "..captureTarget end,
	messageEnd = function() return "Mission ended: Capture "..captureTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		captureTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not captureTarget then return false end
		
		local targetzn = bc:getZoneByName(captureTarget)
		return targetzn.side == 0 and targetzn.active
	end
})

function generateCaptureMission()
	if captureTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 0 and v.active then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		captureTarget = validzones[choice]
		return true
	end
end

function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end

function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)

mc:init()

function respawnStatics()
	for i,v in pairs(cargoSpawns) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					if not StaticObject.getByName(vx) then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = StaticObject.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
	
	for i,v in pairs(farpSupply) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					local gr = Group.getByName(vx)
					if not gr then
						mist.respawnGroup(vx)
					elseif gr:getSize() < gr:getInitialSize() then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = Group.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
end

mist.scheduleFunction(respawnStatics, {}, timer.getTime() + 1, 30)